<template>
  <div
    class="tab-panel"
    :class="{ active: isActive === true, hide: isHide === true }"
  >
    <slot></slot>
  </div>
</template>

<script>
import { computed, inject, watchEffect, getCurrentInstance } from 'vue'

export default {
  name: 'Tab',
  props: {
    title: String
  },
  setup() {
    const instance = getCurrentInstance()
    const { tabs, active, hideTabIndex } = inject('tabsState')

    const index = computed(() =>
      tabs.value.findIndex(target => target.uid === instance.uid)
    )
    const isActive = computed(() => index.value === active.value)
    const isHide = computed(() => index.value === hideTabIndex.value)

    watchEffect(() => {
      if (index.value === -1) {
        tabs.value.push(instance)
      }
    })

    return {
      isActive,
      isHide
    }
  }
}
</script>
